unit U_io;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, Grids, u_types, shellapi, Buttons, Compiler {, coder};

type
  TF_Compiler = class(TForm)
    M_Menu                : TMainMenu;
      M_Datei             : TMenuItem;
        M_neu             : TMenuItem;
        M_oeffnen         : TMenuItem;
        M_speichern       : TMenuItem;
        M_SpeichernUnter  : TMenuItem;
        N1                : TMenuItem;
        M_ende            : TMenuItem;
      M_Compiler          : TMenuItem;
        M_scannen         : TMenuItem;
        M_parsen          : TMenuItem;
        M_codieren        : TMenuItem;
        M_Ausfuehren      : TMenuItem;
        N2                : TMenuItem;
        M_Alles           : TMenuItem;
      M_ausgaben          : TMenuItem;
        M_tabout          : TMenuItem;
        M_listeout        : TMenuItem;
        M_AliProgrammout  : TMenuItem;
      M_Hilfe             : TMenuItem;
        M_Info            : TMenuItem;
    L_Quelltext           : TLabel;
    L_filename            : TLabel;
    L_Symboltabelle       : TLabel;
    L_Tokenliste          : TLabel;
    DLG_Open              : TOpenDialog;
    DLG_Save              : TSaveDialog;
    DLG_Save_ass          : TSaveDialog;
    SG_Symboltabelle      : TStringGrid;
    ME_Quelltext          : TMemo;
    ME_Tokenliste         : TMemo;
    ME_Ali                : TMemo;
    B_Speichern           : TBitBtn;
    L_ParsF               : TLabel;
    L_Meldung1            : TLabel;
    L_ScanF               : TLabel;
    L_Meldung2            : TLabel;
    L_Aliprg              : TLabel;
    procedure M_neuClick           (Sender: TObject);
    procedure M_oeffnenClick       (Sender: TObject);
    procedure M_speichernClick     (Sender: TObject);
    procedure M_scannenClick       (Sender: TObject);
    procedure M_endeClick          (Sender: TObject);
    procedure M_taboutClick        (Sender: TObject);
    procedure M_listeoutClick      (Sender: TObject);
    procedure FormCreate           (Sender: TObject);
    procedure M_parsenClick        (Sender: TObject);
    procedure M_SpeichernUnterClick(Sender: TObject);
    procedure M_codierenClick      (Sender: TObject);
    procedure M_AliProgrammoutClick(Sender: TObject);
    procedure M_AllesClick         (Sender: TObject);
    procedure M_AusfuehrenClick    (Sender: TObject);
    procedure M_InfoClick          (Sender: TObject);
    procedure B_SpeichernClick     (Sender: TObject);
  private
    { Private-Deklarationen }

    FehlerNr: Byte;
    Dateiname: string;
    Compiler: TCompiler;

    procedure init_form;
  public
    { Public-Deklarationen }
  end;

var
  F_Compiler : TF_Compiler;

implementation

{$R *.DFM}

{ private Operationen: ..................................................... }

procedure TF_Compiler.init_form;
begin
  Me_quelltext.clear;
  Me_tokenliste.clear;
  Me_quelltext.visible := true;
  Me_tokenliste.visible:= false;
  ME_Ali.visible:= false;
  SG_Symboltabelle.visible:= false;
  L_filename.caption:= ExtractFileName(Dateiname);
  M_Compiler.enabled:= true;
  M_parsen.enabled:= false;
  M_Codieren.enabled:= false;
  M_Ausfuehren.enabled:= false;
  M_Speichern.enabled:= true;
  M_SpeichernUnter.enabled:= true;
  L_ScanF.Caption:= '';
  L_ParsF.Caption:= '';
end;

{ .......................................................................... }

procedure TF_Compiler.FormCreate(Sender: TObject);
begin
  with SG_Symboltabelle do
  begin
    cells[0,0]:= 'Idx';
    cells[1,0]:= 'Zkette';
    cells[2,0]:= 'Tok';
    cells[3,0]:= 'Adr'
  end;
  Dateiname:= '*.pgm';
end;

procedure TF_Compiler.M_endeClick(Sender: TObject);
begin
  close
end;

procedure TF_Compiler.M_neuClick(Sender: TObject);
begin
  Compiler.Free;
  Compiler:= TCompiler.Create;
  Dateiname:='neu.pgm';
  init_form;
end;

procedure TF_Compiler.M_oeffnenClick(Sender: TObject);
begin
  DLG_Open.Filename:= ExtractFilename(Dateiname);
  if DLG_Open.execute
     then begin
            M_Compiler.enabled:= true;
            Compiler.Free;
            Compiler:= TCompiler.Create;
            Dateiname:= DLG_Open.filename;
            init_form;
            Me_quelltext.lines.LoadFromFile(Dateiname);
          end
end;

procedure TF_Compiler.M_speichernClick(Sender: TObject);
begin
  if Dateiname='neu.pgm'
  then M_SpeichernunterClick(Sender)
  else begin
         L_filename.caption   := ExtractFileName(Dateiname);
         Me_quelltext.lines.SaveToFile(Dateiname)
       end;
end;

procedure TF_Compiler.M_SpeichernUnterClick(Sender: TObject);
begin
  DLG_Save.Filename:= ExtractFilename(Dateiname);
    if DLG_Save.execute
     then begin
            Dateiname:= DLG_Save.filename;
            L_filename.caption   := ExtractFileName(Dateiname);
            Me_quelltext.lines.SaveToFile(Dateiname)
          end
end;

procedure TF_Compiler.M_scannenClick(Sender: TObject);
  var quelltext: textfile;
begin
  Me_quelltext.lines.SaveToFile('temp.pgm');
  AssignFile (quelltext, 'temp.pgm');
  {$I-} Reset(quelltext); {$I+}
  if IOResult > 0
  then          { Fehlermeldung: kann aber nicht passieren ! }
  else begin
         M_tabout.enabled:= true;
         M_listeout.enabled:= true;
         Compiler.Free;
         Compiler:= TCompiler.Create;
         FehlerNr:= Compiler.Scanner.scan (quelltext);
         CloseFile(quelltext);
         L_ScanF.caption:= IntToStr(FehlerNr);
         if FehlerNr > 0
           then messagedlg('Fehler beim Scannen!'+chr(13)+Compiler.Scanner.Fehlermeldung_Scanner(FehlerNr),
                           mtWarning, [mbOK], 0);
         M_parsen.enabled:= FehlerNr=0;
         M_taboutClick(Sender);
         erase(quelltext);
       end;
  M_listeoutClick(Sender);
end;

procedure TF_Compiler.M_taboutClick(Sender: TObject);
var i: TSymbolIndex;
begin
  with SG_Symboltabelle
  do begin
       visible:= true;
       for i:= 1 To maxSymbole
       do begin
            cells[0,i]:= IntToStr(i);
            cells[1,i]:= Compiler.Symboltabelle.SymbolString(i);
            cells[2,i]:= Compiler.Symboltabelle.SymbolKuerzel(Compiler.Symboltabelle.Symbol(i));
          end
     end
end;

procedure TF_Compiler.M_listeoutClick(Sender: TObject);
var Symbolindex: TSymbolIndex;
    i: integer;
    zeile, format: String;
    ausgegeben   : Boolean;
begin
  Me_tokenliste.clear;
  Me_tokenliste.visible:= true;
  Compiler.Tokenliste.AnAnfang;
  if Compiler.Tokenliste.leer
  then Me_tokenliste.lines.add('Liste leer')
  else begin
         while Compiler.Tokenliste.amEnde = false
         do begin
              Symbolindex:= Compiler.Tokenliste.NextTokenIndex;
              case Symbolindex of
                1.. 9: format:= '  ';
                10..99: format:=  ' ';
                else format:=   ''
              end;
              zeile:= format + IntToStr(Symbolindex);
              Me_tokenliste.lines.add(zeile);
            end
       end
end;

procedure TF_Compiler.M_parsenClick(Sender: TObject);
begin
  Compiler.Tokenliste.AnAnfang;
  FehlerNr:= Compiler.Parser.parse;
  if FehlerNr > 0
  then messagedlg('Fehler beim Parsen!'+chr(13)+Compiler.Parser.Fehlermeldung_Parser(FehlerNr), mtWarning, [mbOK], 0);
  L_ParsF.caption:= IntToStr(FehlerNr);
  M_Codieren.enabled:= (FehlerNr=0);
end;

procedure TF_Compiler.M_codierenClick(Sender: TObject);
begin
{  Compiler.Tokenliste.AnAnfang;
  Compiler.Coder.Code;
  M_AliProgrammoutClick(Sender);
  M_Ausfuehren.enabled:= true;
  M_AliProgrammout.enabled:= true;
  M_TaboutClick(Sender);
  }
end;

procedure TF_Compiler.M_AliProgrammoutClick(Sender: TObject);
const leer: string='                                                                                            ';
var s1, s2, s3, s4: string;
    i: integer;
begin
{  Compiler.Coder.Aliprogramm.AnAnfang;
  if not Compiler.Coder.Aliprogramm.leer
  then begin
         B_Speichern.visible:= true;
         ME_Ali.visible:= true;
         ME_Ali.Clear;

         ME_Ali.Lines.Add('******************************');
         ME_Ali.Lines.Add('** Urspruengliches Programm **');
         ME_Ali.Lines.Add('******************************');
         ME_Ali.Lines.Add('');

         for i:= 1 to ME_Quelltext.Lines.Count
         do ME_Ali.Lines.Add('* '+ME_Quelltext.Lines[i]);

         ME_Ali.Lines.Add('******************************');
         ME_Ali.Lines.Add('** Uebersetztes Aliprogramm **');
         ME_Ali.Lines.Add('******************************');
         ME_Ali.Lines.Add('');

         for i:= 1 to Compiler.Coder.Aliprogramm.Anzahl
         do begin
           s1:= (Compiler.Coder.Aliprogramm.Aktuell as TAliprogrammEintrag).Marke;
           s2:= (Compiler.Coder.Aliprogramm.Aktuell as TAliprogrammEintrag).Befehl;
           s3:= (Compiler.Coder.Aliprogramm.Aktuell as TAliprogrammEintrag).Operand;
           s4:= (Compiler.Coder.Aliprogramm.Aktuell as TAliprogrammEintrag).Kommentar;
           s1:= s1+copy(leer,1,9-length(s1));
           s2:= s2+copy(leer,1,9-length(s2));
           s3:= s3+copy(leer,1,14-length(s3));
           s4:= '* '+s4;
           ME_Ali.lines.add (s1+s2+s3+s4);
           Compiler.Coder.Aliprogramm.vor;
         end;
       end;
}
end;

procedure TF_Compiler.M_AllesClick(Sender: TObject);
begin
  M_ScannenClick(Sender);
  M_ParsenClick(Sender);
  M_CodierenClick(Sender);
  M_AusfuehrenClick(Sender);
end;

procedure TF_Compiler.M_AusfuehrenClick(Sender: TObject);
var
  cmdvar : array [0 .. 256] of char;
  tmpstring : string;
begin
{  ME_Ali.Lines.SaveToFile('WinAli\work.ass');

  tmpstring := 'Winali\WinAli.Exe work.ass';
  strplcopy (cmdvar, tmpstring, 255);
  winexec (cmdvar, 1);
  }
end;


procedure TF_Compiler.M_InfoClick(Sender: TObject);
begin
  MessageDlg('Demoprogramm zum Compilerbau'+chr(13)+'(C) 2002, D. Garmann, Version 3.0',
    mtInformation, [mbOK], 0)
end;

procedure TF_Compiler.B_SpeichernClick(Sender: TObject);
begin
  if DLG_Save_ASS.execute
  then ME_Ali.Lines.SaveToFile(DLG_Save_ASS.Filename);
end;

end.
