{ UNIT zur Syntaxanalyse der Tokenliste durch einen TOP-DOWN-Parser ..................................... <PARSER.PAS> }
{                                                                                                                      }
{ Die Tokenliste wird vom Objekt TCompiler bereitgestellt.                                                             }
{                                                                                                                      }
{ Die zugrunde liegende Grammatik: ................................................................................... }
{                                                                                                                      }
{  S         ::= prog name semikolon BLOCK                                                                             }
{  BLOCK     ::= start ANWFOLG ende                                                                                    }
{  ANWFOLG   ::= ANWEISUNG | ANWEISUNG semikolon ANWFOLG                                                               }
{  ANWEISUNG ::= ZUWEISUNG | BLOCK | WENNANW                                                                           }
{  WENNANW   ::= wenn VERGLEICH dann ANWEISUNG (sonst ANWEISUNG)                                                       }
{  VERGLEICH ::= AUSDRUCK vergloperator AUSDRUCK                                                                       }
{  ZUWEISUNG ::= name zuweisungsop AUSDRUCK                                                                            }
{  AUSDRUCK  ::= TERM | TERM strichoperator AUSDRUCK                                                                   }
{  TERM      ::= FAKTOR | FAKTOR punktoperator TERM                                                                    }
{  FAKTOR    ::= name | zahl | klammerauf AUSDRUCK klammerzu                                                           }
{                                                                                                                      }
{                                                                                       Version 3 / 2002 / Ga / Lk12.2 }
{ -------------------------------------------------------------------------------------------------------------------- }

unit Parser;

interface

  uses u_types, u_list;

type TParser = class
       private
       Tokenliste: TTokenListe;                                            { Wird nur lesend bentigt.                 }

       function S (var AktuellesToken: TSymbol ): byte ;                   { Top-Down-Parser-Routinen                  }
        function BLOCK (var AktuellesToken: TSymbol ): byte ;
         function ANWFOLG (var AktuellesToken: TSymbol ): byte ;
          function ANWEISUNG (var AktuellesToken: TSymbol ): byte ;
           function WENNANW (var AktuellesToken: TSymbol ): byte ;
            function VERGLEICH (var AktuellesToken: TSymbol ): byte ;
           function ZUWEISUNG (var AktuellesToken: TSymbol ): byte ;
            function AUSDRUCK (var AktuellesToken: TSymbol ): byte ;
             function TERM (var AktuellesToken: TSymbol ): byte ;
              function FAKTOR (var AktuellesToken: TSymbol ): byte ;

       public
       constructor create(TL: TTokenliste);                                { Tokenliste wird bergeben (lesend)        }
       function Parse: byte;                                               { Parst den Quelltext mit Rckgabe FehlerNr }
       function Fehlermeldung_Parser(FehlerNr: Byte): string;              { Entschlsselung der FehlerNr.             }
     end;

implementation

constructor TParser.Create(TL: TTokenliste);
begin
  Tokenliste:= TL;
end;


function TParser.parse: byte;
var FehlerNr: Byte;
    AktuellesToken: TSymbol;
begin { of parse }
  FehlerNr:= 0;
  AktuellesToken := Tokenliste.NextToken;                                  { Erstes Token der Tokenliste holen         }
  if AktuellesToken=leer                                                   { wenn kein Token vorhanden                 }
  then FehlerNr:=1                                                         {   dann Fehler: "unerwartetes Dateiende"   }
  else FehlerNr:= S(AktuellesToken);                                       {   sonst Startregel aufrufen               }
  parse:= FehlerNr;                                                        { FehlerNr nach oben zurckreichen          }
end; { of parse }

  function TParser.S (var AktuellesToken: TSymbol ): byte ;
  var FehlerNr: byte;
  begin { of S, der Startregel }
    FehlerNr:= 0;                                                          { erst mal davon ausgehen, dass kein Fehler }
    if AktuellesToken <> prog                                              { wenn erstes Token nicht "program" ist     }
    then FehlerNr:=2                                                       {   dann Fehler: "program erwartet"         }
    else begin                                                             {   sonst nchstes Token holen              }
          AktuellesToken:= Tokenliste.NextToken;
          if AktuellesToken=leer                                           {         welches nicht leer sein darf      }
          then FehlerNr:=1
          else begin
                 if AktuellesToken <> name                                 {         und gleich "name" sein sollte     }
                 then FehlerNr:=3
                 else begin
                        AktuellesToken:= Tokenliste.NextToken;             {         ist es "name" dann nchstes Token }
                        if AktuellesToken=leer                             {         welches nicht leer sein darf      }
                        then FehlerNr:=1
                        else begin
                               if AktuellesToken<> semikolon               {         und gleich "semikolon" sein sollte}
                               then FehlerNr:=20
                               else begin
                                     AktuellesToken:= Tokenliste.NextToken;{         ist es ";" dann nchstes Token    }
                                     if AktuellesToken=leer                {         welches nicht leer sein darf      }
                                     then FehlerNr:=1
                                     else begin
                                            FehlerNr:= BLOCK(AktuellesToken); {      und Aufruf der Regel BLOCK        }
                                            if FehlerNr = 0
                                            then begin
                                                   if AktuellesToken <> punkt {      am Schluss noch ein Punkt?        }
                                                   then FehlerNr:=4
                                                 end;
                                          end;
                                    end;
                             end;
                      end;
               end;
         end;
    S:= FehlerNr;
  end { of S, der Startregel };

   function TParser.BLOCK (var AktuellesToken: TSymbol ): byte ;
   var FehlerNr: byte;
   begin { of block }
     FehlerNr:= 0;
     if AktuellesToken <> start
     then FehlerNr:=5
     else begin
            AktuellesToken:= Tokenliste.NextToken;
            if AktuellesToken=leer
            then FehlerNr:=1
            else begin
                   FehlerNr:= ANWFOLG(AktuellesToken);
                   if FehlerNr = 0
                   then begin
                          if AktuellesToken <> ende
                          then FehlerNr:=6
                          else begin
                                 AktuellesToken:= Tokenliste.NextToken;
                                 if AktuellesToken=leer
                                 then FehlerNr:=1
                               end
                        end
                 end
          end;
     BLOCK:= FehlerNr;
   end; { of block }

     function TParser.ANWFOLG (var AktuellesToken: TSymbol ): byte ;
     var FehlerNr: byte;
     begin { of anwfolg }
       FehlerNr:= 0;
       FehlerNr:= ANWEISUNG(AktuellesToken);
       if FehlerNr = 0
       then begin
              if AktuellesToken = semikolon
              then begin
                     AktuellesToken:= Tokenliste.NextToken;
                     if AktuellesToken=leer
                     then FehlerNr:=1
                     else FehlerNr:= ANWFOLG(AktuellesToken);
                   end
            end;
       anwfolg:= FehlerNr;
     end; { of anwfolg }

       function TParser.ANWEISUNG (var AktuellesToken: TSymbol ): byte ;
       var FehlerNr: byte;
       begin { of anweisung }
         FehlerNr:= 0;
         case AktuellesToken of
           name:       FehlerNr:= ZUWEISUNG(AktuellesToken);
           start:      FehlerNr:= BLOCK(AktuellesToken);
           wenn:       FehlerNr:= WENNANW(AktuellesToken);
           else    { leere Anweisung }
         end;
         ANWEISUNG:= FehlerNr;
       end { of anweisung };

         function TParser.WENNANW (var AktuellesToken: TSymbol ): byte ;
         var FehlerNr: byte;
         begin { of WENNANW }
           FehlerNr:= 0;
           if AktuellesToken <> wenn
           then FehlerNr:=12
           else begin
                  AktuellesToken:= Tokenliste.NextToken;
                  if AktuellesToken=leer
                  then FehlerNr:=1
                  else begin
                         FehlerNr:= VERGLEICH(AktuellesToken);
                         if FehlerNr = 0
                         then begin
                                if AktuellesToken <> dann
                                then FehlerNr:= 13
                                else begin
                                       AktuellesToken:= Tokenliste.NextToken;
                                       if AktuellesToken= leer
                                       then FehlerNr:= 1
                                       else begin
                                              FehlerNr:= ANWEISUNG(AktuellesToken);
                                              if FehlerNr = 0
                                              then begin
                                                     if AktuellesToken=sonst
                                                     then begin
                                                            AktuellesToken:= Tokenliste.NextToken;
                                                            if AktuellesToken=leer
                                                            then FehlerNr:= 1
                                                            else FehlerNr:= ANWEISUNG(AktuellesToken);
                                                          end;
                                                   end;
                                            end;
                                     end;
                              end;
                       end;
                end;
           WENNANW:= FehlerNr;
         end; { of WENNANW }

               function TParser.VERGLEICH (var AktuellesToken: TSymbol ): byte ;
               var FehlerNr: byte;
               begin { of VERGLEICH }
                 FehlerNr:= 0;
                 FehlerNr:= AUSDRUCK(AktuellesToken);
                 if FehlerNr = 0
                 then begin
                        if AktuellesToken <> vergleichsop
                        then FehlerNr:= 14
                        else begin
                               AktuellesToken:= Tokenliste.NextToken;
                               if AktuellesToken=leer
                               then FehlerNr:=1
                               else FehlerNr:= AUSDRUCK(AktuellesToken);
                             end
                      end;
                  VERGLEICH:= FehlerNr;
               end; { of VERGLEICH }

         function TParser.ZUWEISUNG (var AktuellesToken: TSymbol ): byte ;
         var FehlerNr: byte;
         begin { of ZUWEISUNG }
           FehlerNr:= 0;
           if AktuellesToken <> name
           then FehlerNr:=3
           else begin
                  AktuellesToken:= Tokenliste.NextToken;
                  if AktuellesToken=leer
                  then FehlerNr:=1
                  else begin
                         if AktuellesToken <> zuweisungsop
                         then FehlerNr:=7
                         else begin
                                AktuellesToken:= Tokenliste.NextToken;
                                if AktuellesToken=leer
                                then FehlerNr:=1
                                else FehlerNr:= AUSDRUCK(AktuellesToken);
                              end
                       end
                end;
           ZUWEISUNG:= FehlerNr;
         end { of ZUWEISUNG };

          function TParser.AUSDRUCK (var AktuellesToken: TSymbol ): byte ;
          var FehlerNr: byte;
          begin { of AUSDRUCK }
            FehlerNr:= 0;
            FehlerNr:= TERM(AktuellesToken);
            if FehlerNr = 0
            then begin
                   if AktuellesToken = strichoperator
                   then begin
                          AktuellesToken:= Tokenliste.NextToken;
                          if AktuellesToken=leer
                          then FehlerNr:=1
                          else FehlerNr:= AUSDRUCK(AktuellesToken);
                        end
                 end;
            AUSDRUCK:= FehlerNr;
          end; { of AUSDRUCK }

           function TParser.TERM (var AktuellesToken: TSymbol ): byte ;
           var FehlerNr: byte;
           begin { of TERM }
              FehlerNr:= 0;
              FehlerNr:= FAKTOR(AktuellesToken);
              if FehlerNr = 0
              then begin
                     if AktuellesToken = punktoperator
                     then begin
                            AktuellesToken:= Tokenliste.NextToken;
                            if AktuellesToken=leer
                            then FehlerNr:=1
                            else FehlerNr:= TERM(AktuellesToken);
                          end
                   end;
              TERM:= FehlerNr;
           end { of TERM };


            function TParser.FAKTOR (var AktuellesToken: TSymbol ): byte ;
            var FehlerNr: byte;
            begin { of FAKTOR }
              FehlerNr:= 0;
              if AktuellesToken = klammerauf
              then begin
                     AktuellesToken:= Tokenliste.NextToken;
                     if AktuellesToken=leer
                     then FehlerNr:=1
                     else begin
                            FehlerNr:= AUSDRUCK(AktuellesToken);
                            if FehlerNr = 0
                            then begin
                                   if AktuellesToken <> klammerzu
                                   then FehlerNr:=8
                                   else begin
                                          AktuellesToken:= Tokenliste.NextToken;
                                          if AktuellesToken=leer
                                          then FehlerNr:=1
                                        end;
                                 end
                          end
                   end
              else begin
                     if not (AktuellesToken in [zahl,name])
                     then FehlerNr:=9
                     else begin
                            AktuellesToken:= Tokenliste.NextToken;
                            if AktuellesToken=leer
                            then FehlerNr:=1
                          end
                   end;
              FAKTOR:= FehlerNr;
            end; { of FAKTOR }



function TParser.Fehlermeldung_Parser(FehlerNr: Byte): string;
begin
  case FehlerNr of
    0: Fehlermeldung_Parser:= 'Parsing erfolgreich!';
    1: Fehlermeldung_Parser:= 'Unerwartetes Dateiende!';
    2: Fehlermeldung_Parser:= '"program" erwartet!';
    3: Fehlermeldung_Parser:= 'Bezeichner erwartet!';
    4: Fehlermeldung_Parser:= 'Punkt (.) erwartet!';
    5: Fehlermeldung_Parser:= '"begin" erwartet!';
    6: Fehlermeldung_Parser:= '"end" erwartet!';
    7: Fehlermeldung_Parser:= 'Zuweisungsoperator (:=) erwartet!';
    8: Fehlermeldung_Parser:= 'Klammer ) erwartet!';
    9: Fehlermeldung_Parser:= 'Bezeichner oder Zahl erwartet!';
   12: Fehlermeldung_Parser:= 'if erwartet!';
   13: Fehlermeldung_Parser:= 'then erwartet!';
   14: Fehlermeldung_Parser:= 'Vergleichsoperator erwartet!';
   20: Fehlermeldung_Parser:= 'Semikolon (;) erwartet!';
  end;
end;


end.