{ UNIT fr die Deklaration der Tokenliste und der Symboltabelle ........................................ <U_TYPES.PAS> }
{                                                                                                                      }
{ Symboltabelle und Tokenliste werden als Klassen deklaraiert                                                          }
{                                                                                                                      }
{ Die Tokenliste als Ableitung der Klasse TLinList                                                                     }
{                                                                                                                      }
{ Die Symboltabelle als neue Klasse                                                                                    }
{                                                                                                                      }
{ .................................................................................................................... }
{                                                                                                                      }
{                                                                                       Version 3 / 2002 / Ga / Lk12.2 }
{ -------------------------------------------------------------------------------------------------------------------- }

unit U_types;

interface

uses u_list;

   const  { zunchst die verschiedenen Mengen von Zeichen: }

          Buchstaben     : set of char = ['a'..'z','A'..'Z','_','','','','','',''];
          ziffern        : set of char = ['0'..'9'];
          kontrollzeichen: set of char = [#10,#13,#32];

          { und schlielich die festen Max-Konstanten: }

          maxSymbole          = 100; { maximal 100 verschiedene Symbole              }
          maxBezeichnerLaenge =  20; { Bezeichnerlnge ist auf 20 Zeichen beschrnkt }

   type
         { Der Typ TSymbol beschreibt die unterschiedlichen tokens ! }
          TSymbol       = (prog,          start,           ende,            punkt,   klammerauf, klammerzu,
                           zuweisungsop,  punktoperator,   strichoperator,  zahl,    name,       wenn,
                           dann,          sonst,           vergleichsop,    semikolon,
                           nicht_zulaessig,     leer);

          TSymbolindex   = 0..maxSymbole;

          TSymbolString  = string [maxBezeichnerLaenge];

          TSymbolEintrag =  record
                                 Zeichenkette  : TSymbolString ;
                                 Symbol        : TSymbol       ;
                            end;

          TSymbolTabelle = class
            private
            Items: array [1..maxSymbole] of TSymbolEintrag ;

            public
            constructor create;
            function SymbolString ( i: TSymbolindex  ) : String;
            function Symbol       ( i: TSymbolindex  ) : TSymbol ;
            function SymbolKuerzel( symbol : TSymbol ) : String ;

            function SymbolIndex  (Zeichenkette: TSymbolstring): TSymbolindex;
          end;

          TSymbolelement = class(TElement)
            Inhalt: TSymbolindex;
            constructor create(i: TSymbolindex);
          end;

          TTokenliste    = class
            private
            liste: TList; { ber dem Typ TSymbolindex }
            Symboltabelle: TSymboltabelle;

            public
            constructor create(ST: TSymboltabelle);
            procedure einfuegen(Symbolindex: TSymbolindex);
            procedure anAnfang;
            function amEnde: boolean;
            function leer: boolean;
            function NextTokenIndex: TSymbolIndex;
            function NextToken: TSymbol;
          end;

implementation

{ ------------------     Routinen fr die Symboltabelle    ---------------------------------------- }

constructor TSymboltabelle.create;
var   i : integer ;
begin
   for i := 1  to  maxSymbole
   do with Items[i]
   do begin
        Zeichenkette  := ''   ;
        Symbol  := leer ;
      end;
   Items[ 1].symbol := klammerauf     ; Items[ 1].Zeichenkette:= '('      ;
   Items[ 2].symbol := klammerzu      ; Items[ 2].Zeichenkette:= ')'      ;
   Items[ 3].symbol := punkt          ; Items[ 3].Zeichenkette:= '.'      ;
   Items[ 4].symbol := zuweisungsop   ; Items[ 4].Zeichenkette:= ':='     ;
   Items[ 5].symbol := prog           ; Items[ 5].Zeichenkette:= 'program';
   Items[ 6].symbol := start          ; Items[ 6].Zeichenkette:= 'begin'  ;
   Items[ 7].symbol := ende           ; Items[ 7].Zeichenkette:= 'end'    ;
   Items[ 8].symbol := strichoperator ; Items[ 8].Zeichenkette:= '+'      ;
   Items[ 9].symbol := strichoperator ; Items[ 9].Zeichenkette:= '-'      ;
   Items[10].symbol := punktoperator  ; Items[10].Zeichenkette:= '*'      ;
   Items[11].symbol := punktoperator  ; Items[11].Zeichenkette:= '/'      ;
   Items[12].symbol := semikolon      ; Items[12].Zeichenkette:= ';'      ;

   Items[13].symbol := punktoperator  ; Items[13].Zeichenkette:= 'mod'    ;

   Items[14].symbol := wenn           ; Items[14].Zeichenkette:= 'if'     ;
   Items[15].symbol := dann           ; Items[15].Zeichenkette:= 'then'   ;
   Items[16].symbol := sonst          ; Items[16].Zeichenkette:= 'else'   ;

   Items[17].symbol := vergleichsop   ; Items[17].Zeichenkette:= '='      ;
   Items[18].symbol := vergleichsop   ; Items[18].Zeichenkette:= '>'      ;
   Items[19].symbol := vergleichsop   ; Items[19].Zeichenkette:= '>='     ;
   Items[20].symbol := vergleichsop   ; Items[20].Zeichenkette:= '<='     ;
   Items[21].symbol := vergleichsop   ; Items[21].Zeichenkette:= '<'      ;
   Items[22].symbol := vergleichsop   ; Items[22].Zeichenkette:= '<>'     ;

   Items[23].symbol := nicht_zulaessig; Items[23].Zeichenkette:= '??'     ;
end;


function TSymboltabelle.SymbolIndex(Zeichenkette: TSymbolstring): TSymbolindex;
var i: TSymbolIndex;
begin
   i := 0;
   repeat
     i := succ(i);
   until (Items[i].symbol = leer) or (Items[i].Zeichenkette = Zeichenkette)
                                  or (i = maxSymbole-1) ;
      { i=max_Symbole bleibt dem token 'leer' bzw. 'nn' vorbehalten ! }

   if (Items[i].Zeichenkette <> ZeichenKette) and (i = maxSymbole)
   then SymbolIndex:= 0             { ---- Fall: Symboltabelle zu klein ausgelegt }

   else begin
          if Items[i].Symbol = leer { ---- Fall: Bezeichner oder Zahl neu anzulegen   }
          then begin
                 Items[i].Zeichenkette := Zeichenkette;
                 if Zeichenkette[1] in Buchstaben
                 then Items[i].Symbol:= name
                 else Items[i].Symbol:= zahl;
               end;
          SymbolIndex:= i
        end
 end;

  function TSymboltabelle.SymbolString(i: TSymbolIndex): String;
  begin
    SymbolString:= Items[i].Zeichenkette
  end;

  function TSymboltabelle.Symbol(i: TSymbolIndex): TSymbol;
  begin
    Symbol:= Items[i].symbol
  end;

  function TSymboltabelle.SymbolKuerzel( symbol: TSymbol ): String ;    {eine Klassifizierung}
  var s: String;
  begin
    case symbol of name                         : s:= 'Id' ;
                   zahl                         : s:= 'Zi' ;
                   punktoperator,strichoperator,
                   zuweisungsop                 : s:= 'Op' ;
                   nicht_zulaessig              : s:= '??' ;
                   leer                         : s:= 'nn' ;
       {Sonderzeichen}
                   klammerauf, klammerzu,
                   semikolon,punkt              : s:= 'Sz' ;
       {Schlsselwort}
                   prog, start, ende,
                   wenn, dann, sonst            : s:= 'Sw' ;
    end ;
    SymbolKuerzel:= s
  end ;


{ ------------------     Routinen fr die Tokenliste    ------------------------------------------- }

constructor TSymbolElement.create(i: TSymbolindex);
begin
  inherited create;
  Inhalt:= i;
end;

constructor TTokenliste.create(ST: TSymboltabelle);
begin
  inherited create;
  liste:= TList.create;
  Symboltabelle:= ST;
end;

function TTokenliste.NextTokenIndex: TSymbolIndex;
var nr: integer;
begin
  begin
    if not liste.isEmpty                                 { die tokenliste wird durch 'leer' vom Scanner abgeschlossen! }
    then begin
           nr:= (liste.getItem as TSymbolElement).Inhalt;
           liste.next;                                          { kein Effekt bei erreichtem Ende!                            }
         end
    else nr := maxSymbole;                               { d.h. leer!                                                  }
    NextTokenIndex:= nr;
  end;

end;

function TTokenliste.NextToken: TSymbol;
var nr: integer;
begin
  nr:= NextTokenIndex;
  NextToken:= Symboltabelle.Symbol(nr);
end;

procedure TTokenliste.einfuegen(Symbolindex: TSymbolindex);
begin
  liste.insertBehind(TSymbolElement.create(Symbolindex));
  liste.next;
end;

procedure TTokenliste.anAnfang;
begin
  liste.toFirst;
end;

function TTokenliste.leer: boolean;
begin
  result:= (liste.isEmpty);
end;

function TTokenliste.amEnde: boolean;
begin
  result:= (liste.isBehind);
end;

end.
